<?php
/*
Plugin Name: WP-Anti-Spam
Plugin URI: http://boliquan.com/wp-anti-spam/
Description: WP Anti Spam can anti spams by "author","email","url","comment","ip". You just need to set the banned words at the admin page, and it can also anti the english spams if you need . Besides,it can delete its own options, so it is also a green plugin ! 
Version: 1.1.7
Author: BoLiQuan
Author URI: http://boliquan.com/
Text Domain: WP-Anti-Spam
Domain Path: /lang
*/

function load_wp_anti_spam_lang() {
		$currentLocale = get_locale();
		if(!empty($currentLocale)) {
			$moFile = dirname(__FILE__) . "/lang/wp-anti-spam-" . $currentLocale . ".mo";
			if(@file_exists($moFile) && is_readable($moFile)) load_textdomain('WP-Anti-Spam', $moFile);
		}
}
add_filter('init','load_wp_anti_spam_lang');

$wp_anti_spam_words = array();

function wp_anti_spam($comment_data){
	
	$wp_anti_spam_words = explode("\r\n", get_option("wp_anti_spam_words"));
	$comment_fields = array('author','email','url','comment');

	foreach($wp_anti_spam_words as $wp_anti_spam_word)
	foreach($comment_fields as $comment_field)
	if( $wp_anti_spam_word != '' && isset($_POST[$comment_field]) ){
		if(eregi($wp_anti_spam_word, $_POST[$comment_field]) !== false) {
 			wp_die(__('Error: The information you submit contains banned words.','WP-Anti-Spam').'<br /><div style="font-style:italic; font-size:10px;">--- Protected by <a href="http://boliquan.com/wp-anti-spam/" target="_blank">WP Anti Spam</a></div>');
		}
	}

	$visitor_ip = (@getenv("REMOTE_ADDR")) ? getenv("REMOTE_ADDR") : $_SERVER['REMOTE_ADDR'];
	if(in_array($visitor_ip,$wp_anti_spam_words)){
		wp_die(__('Error: Your IP has been banned to leave comments.','WP-Anti-Spam').'<br /><div style="font-style:italic; font-size:10px;">--- Protected by <a href="http://boliquan.com/wp-anti-spam/" target="_blank">WP Anti Spam</a></div>');
	}
	
	$wp_anti_spam_cn_must=get_option("wp_anti_spam_cn_must");
	if($wp_anti_spam_cn_must=='yes'){
		$cn_char = '/[一-龥]/u';
		if(!preg_match($cn_char, $comment_data['comment_content'])) {
			wp_die(__('Error: Comments must contain Chinese.','WP-Anti-Spam').'<br /><div style="font-style:italic; font-size:10px;">--- Protected by <a href="http://boliquan.com/wp-anti-spam/" target="_blank">WP Anti Spam</a></div>');
		}
	}

	return( $comment_data );
}

add_filter('preprocess_comment', 'wp_anti_spam');

function wp_anti_spam_admin() {
	add_options_page('WP Anti Spam Options', 'WP-Anti-Spam','manage_options', __FILE__, 'wp_anti_spam_options');
}
function wp_anti_spam_options(){
?>
<div class="wrap">
	
<?php screen_icon(); ?>
<h2><?php _e( 'WP-Anti-Spam Options','WP-Anti-Spam'); ?></h2>
<div style="text-align:center;"><a href="http://boliquan.com/wp-anti-spam/" target="_blank" title="WP-Anti-Spam FAQ"><?php _e( 'How to use WP Anti Spam ?','WP-Anti-Spam'); ?></a></div>

<form action="options.php" method="post" enctype="multipart/form-data" name="wp_anti_spam_form">
<?php wp_nonce_field('update-options'); ?>

<table class="form-table">
	<tr valign="top">
		<th scope="row">
			<?php _e('Words (one per line)','WP-Anti-Spam'); ?>
		</th>
		<td>
			<label>
				<textarea type="text" name="wp_anti_spam_words" cols="50" rows="16" style="width:90%;font-size:12px;"><?php echo get_option('wp_anti_spam_words'); ?></textarea>
				<br /><?php _e('Comments will be banned contain the above words, no matter the words appear in "author","email","url","comment" or "ip".','WP-Anti-Spam'); ?>
			</label>
		</td>
	</tr>
	<tr valign="top">
		<th scope="row">
			<?php _e('Some Chinese','WP-Anti-Spam'); ?>
		</th>
		<td>
			<label>
				<input type="checkbox" name="wp_anti_spam_cn_must" value="yes" <?php $wp_anti_spam_cn_must=get_option("wp_anti_spam_cn_must"); if($wp_anti_spam_cn_must=='yes') echo 'checked="checked"'; ?> />
				<?php _e("Comments must contain Chinese, if you do not speak Chinese, please don't check it.",'WP-Anti-Spam'); ?>
			</label>
		</td>
	</tr>
	<tr valign="top">
		<th scope="row">
			<?php _e('Delete Options','WP-Anti-Spam'); ?>
		</th>
		<td>
			<label>
				<input type="checkbox" name="wp_anti_spam_deactivate" value="yes" <?php $wp_anti_spam_deactivate=get_option("wp_anti_spam_deactivate"); if($wp_anti_spam_deactivate=='yes') echo 'checked="checked"'; ?> />
				<?php _e('Delete options while deactivate this plugin.','WP-Anti-Spam'); ?>
			</label>
		</td>
	</tr>
	<tr valign="top">
		<th scope="row">
			Support Author
		</th>
		<td>
			<select name="wp_anti_spam_support">
				<option value="yes" <?php if (get_option('wp_anti_spam_support') == 'yes') { echo 'selected="selected"'; } ?>>support author</option>
				<option value="no" <?php if (get_option('wp_anti_spam_support') == 'no') { echo 'selected="selected"'; } ?>>do not support</option>
			</select>
		</td>
	</tr>
</table>

<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="wp_anti_spam_words,wp_anti_spam_cn_must,wp_anti_spam_deactivate,wp_anti_spam_support" />

<p class="submit">
<input type="submit" class="button-primary" name="Submit" value="<?php _e('Save Changes','WP-Anti-Spam') ?>" />
</p>

</form>

<?php $blq_logo_url = plugins_url('blq_32_32.jpg', __FILE__);?>
<div class="icon32"><a href="http://boliquan.com/" target="_blank" title="BoLiQuan"><img src="<?php echo $blq_logo_url; ?>" alt="BoLiQuan" /></a></div>
<h2>Related Links</h2>
<ul style="margin:0 18px;">
<li><a href="http://boliquan.com/wp-anti-spam/" target="_blank" title="WP-Anti-Spam FAQ">WP-Anti-Spam FAQ</a></li>
<li><a href="http://boliquan.com/yg-share/" target="_blank" title="YG-Share">YG-Share</a></li>
<li><a href="http://boliquan.com/" target="_blank" title="BoLiQuan">BoLiQuan</a></li>
<li><a href="http://boliquan.com/ylife/" target="_blank" title="YLife">YLife</a> | <a href="http://code.google.com/p/ylife/downloads/list" target="_blank" title="YLife">Download</a></li>
</ul>

<div style="text-align:center; margin:60px 0 10px 0;">&copy; 2011 BoLiQuan</div>

</div>

<?php 
}
add_action('admin_menu', 'wp_anti_spam_admin');

$wp_anti_spam_deactivate=get_option("wp_anti_spam_deactivate");
if($wp_anti_spam_deactivate=='yes'){
	function yg_deactivate(){
		global $wpdb;
		$remove_options_sql = "DELETE FROM $wpdb->options WHERE $wpdb->options.option_name like 'wp_anti_spam_%'";
		$wpdb->query($remove_options_sql);
	}
	register_deactivation_hook(__FILE__,'yg_deactivate');
}

if(get_option("wp_anti_spam_support")!='no'){
	function support_author(){
		echo '<div style="text-align:center; font-style:italic; font-size:10px;">Protected by <a href="http://boliquan.com/wp-anti-spam/" target="_blank">WP Anti Spam</a></div>';
	}
	add_action('comment_form','support_author');
}
?>